package com.extensibility.plugin.print;

import com.extensibility.plugin.PluginRegistry;
import com.extensibility.plugin.api.PrintHtml10;
import horst.HTMLPane;
import horst.HTMLPaneStatusEvent;
import horst.HTMLPaneStatusListener;
import horst.HTMLWindow;
import java.awt.AWTEvent;
import java.io.File;
import java.io.Reader;
import java.net.URL;

public class HtmlPrint implements PrintHtml10, HTMLPaneStatusListener {
   private HTMLWindow htmlWindow = new HTMLWindow();
   private HTMLPane htmlRenderer;
   private File toDeleteWhenDone;
   private boolean printWhenLoaded;
   private boolean loaded;

   public static void registerPlugin(PluginRegistry var0) {
      var0.registerPlugin("PrintHtml10", Class.forName("com.extensibility.plugin.print.HtmlPrint"), "HTML Printer", 65538);
   }

   public HtmlPrint() {
      this.htmlRenderer = this.htmlWindow.getHTMLPane();
      this.htmlRenderer.addStatusListener(this);
   }

   public void setHtmlToPrint(Reader var1, URL var2) {
      this.htmlRenderer.openPage(var1, var2);
      this.printWhenLoaded = true;
   }

   public void setHtmlToPrint(URL var1) {
      this.htmlRenderer.openPage(var1);
      this.printWhenLoaded = true;
   }

   public void doPrinting(File var1) {
      this.toDeleteWhenDone = var1;
   }

   public boolean statusChanged(HTMLPaneStatusEvent var1) {
      if (((AWTEvent)var1).getID() == 5) {
         this.htmlRenderer.printPage();
         if (this.toDeleteWhenDone != null) {
            this.toDeleteWhenDone.delete();
         }
      }

      return true;
   }
}
