package com.extensibility.plugin.xcaccess;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.Window;
import java.awt.event.ActionListener;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import javax.swing.AbstractButton;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.text.JTextComponent;

public class XCUI {
   public static final String PREFS_USER_NAME = "plugin.resloc.xcaccess.user";
   public static final String PREFS_RECENT = "plugin.resloc.xcaccess.recent";
   private static ResourceBundle theBundle = null;
   private static final String RESOURCE_PATH = "com.extensibility.plugin.xcaccess.UIResources";

   public static String getString(String var0) {
      ResourceBundle var1 = getBundle();
      String var2 = null;

      try {
         if (var1 != null) {
            var2 = var1.getString(var0);
         }
      } catch (MissingResourceException var4) {
      }

      if (var2 == null) {
         var2 = String.valueOf("#MISSING").concat(String.valueOf(var0));
      }

      return var2;
   }

   public static String getString(String var0, String var1) {
      String var2 = getString(var0);
      int var3 = var2.indexOf("{0}");
      if (var3 >= 0) {
         var2 = String.valueOf(String.valueOf(var2.substring(0, var3)).concat(String.valueOf(var1))).concat(String.valueOf(var2.substring(var3 + 3)));
      }

      return var2;
   }

   public static char getChar(String var0) {
      return getString(var0).charAt(0);
   }

   public static ResourceBundle getBundle() {
      if (theBundle == null) {
         try {
            theBundle = ResourceBundle.getBundle("com.extensibility.plugin.xcaccess.UIResources");
         } catch (Exception var1) {
         }
      }

      return theBundle;
   }

   public static void addLabel(Container var0, GridBagConstraints var1, String var2) {
      JLabel var3 = new JLabel(getString(var2));
      var1.weightx = (double)0.0F;
      var1.fill = 0;
      var1.gridwidth = 1;
      var0.add(var3, var1);
   }

   public static JTextField createTextField() {
      JTextField var0 = new JTextField();
      ((JTextComponent)var0).setMargin(new Insets(1, 3, 1, 3));
      return var0;
   }

   public static void centerInOwner(Window var0) {
      Container var1 = ((Component)var0).getParent();
      Rectangle var2 = ((Component)var1).getBounds();
      Dimension var3 = ((Component)var0).getSize();
      ((Component)var0).setLocation(var2.x + (var2.width - var3.width) / 2, var2.y + (var2.height - var3.height) / 2);
   }

   public static ButtonStrip createOkCancel(ActionListener var0, ActionListener var1) {
      ButtonStrip var2 = new ButtonStrip();
      Box var3 = Box.createHorizontalBox();
      ((Container)var3).add(Box.createHorizontalGlue());
      JButton var4 = new JButton(getString("dialog.cancel"));
      ((AbstractButton)var4).addActionListener(var1);
      ((AbstractButton)var4).setMnemonic(getChar("dialog.cancel"));
      ((Container)var3).add(var4);
      ((Container)var3).add(Box.createHorizontalStrut(8));
      JButton var5 = new JButton(getString("dialog.ok"));
      ((AbstractButton)var5).addActionListener(var0);
      ((Container)var3).add(var5);
      var2.strip = var3;
      var2.okButton = var5;
      var2.cancelButton = var4;
      return var2;
   }
}
